<template>
  <el-container style="height: 100%">
    <el-header>
      <commonheader></commonheader>
    </el-header>
    <el-container>
      <el-aside width="auto">
        <commonaside></commonaside>
      </el-aside>
      <el-main>
        <div>
          <h2 align="center"><strong>修改健身服务</strong></h2>
          <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="120px" class="demo-ruleForm">
            <el-form-item label="服务名称" prop="serviceName">
              <el-input style="width:300px" v-model="ruleForm.serviceName" placeholder="请输入服务名称"></el-input>
            </el-form-item>
            <el-form-item label="服务图片" ref="uploadElement" prop="imageUrl">
              <el-input v-model="ruleForm.imageUrl" v-if="false"></el-input>
              <el-upload
                class="avatar-uploader"
                ref="upload"
                :show-file-list="false"
                action="/index/upload"
                :before-upload="beforeUpload"
                :on-change="handleChange"
                :auto-upload="false"
                :data="ruleForm">
                <img v-if="ruleForm.imageUrl" :src="ruleForm.imageUrl" class="avatar">
                <i v-else class="el-icon-plus avatar-uploader-icon"></i>
              </el-upload>
            </el-form-item>
            <el-form-item label="服务介绍" prop="serviceIntroduction">
              <el-input type="textarea" v-model="ruleForm.serviceIntroduction" placeholder="请输入服务介绍"></el-input>
            </el-form-item>
            <el-form-item label="服务类型" prop="serviceCategory">
              <el-input style="width:300px" v-model="ruleForm.serviceCategory" placeholder="请输入服务类型"></el-input>
            </el-form-item>
            <el-form-item label="服务地点" prop="serviceLocation">
              <el-input style="width:300px" v-model="ruleForm.serviceLocation" placeholder="请输入服务地点"></el-input>
            </el-form-item>
            <el-form-item label="服务时间" prop="serviceTime">
              <el-input style="width: 300px" v-model="ruleForm.serviceTime" placeholder="请输入服务时间"></el-input>
            </el-form-item>
            <el-form-item label="卡路里/分钟" prop="serviceCalorie">
              <el-input-number style="width: 200px" v-model="ruleForm.serviceCalorie" placeholder="请输入卡路里值"></el-input-number>
            </el-form-item>
            <el-form-item style="margin-top: 50px">
              <el-row>
                <el-col :span="9">
                  <el-button type="primary" size="mini" @click="submitForm('ruleForm')" :disabled="ruleForm.disabled===true">立即申请</el-button>
                </el-col>
                <el-col :span="9">
                  <el-button type="danger" size="mini" @click="resetForm('ruleForm')" :disabled="ruleForm.disabled===true">重置</el-button>
                </el-col>
              </el-row>
            </el-form-item>
          </el-form>
        </div>
      </el-main>
    </el-container>
  </el-container>
</template>

<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import modifyservice from '../services/modifyservice.js'

export default {
  name: 'addservice',
  components: {
    commonaside,
    commonheader
  },
  data () {
    var validatapass = (rule, value, callback) => {
      if (value === '') {
        this.registerMsg = '输入不全'
        callback(new Error('请补全输入'))
      } else {
        callback()
      }
    }
    return {
      ruleForm: {
        shopId: 0,
        serviceName: '',
        serviceIntroduction: '',
        serviceCategory: '',
        serviceTime: '',
        imageUrl: '',
        serviceLocation: '',
        disabled: false
      },
      rules: {
        imageUrl: [
          {required: true, message: '请上传图片', validator: validatapass}
        ],
        serviceIntroduction: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        serviceName: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        serviceCategory: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        serviceTime: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        serviceCalorie: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        serviceLocation: [
          { trigger: 'blur', message: '不能为空', required: true }
        ],
        shopId: [
          { trigger: 'blur', message: '不能为空', required: true }
        ]
      }
    }
  },
  created () {
    // this.getservicecheck()
    this.getservice()
  },
  methods: {
    async getservicecheck () {
      try {
        await modifyservice.getcheck(this.$route.params.shopId, this.$route.params.serviceId, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log('成功')
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          await this.$alert('商品不存在', '请求失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/browseService/' + this.$route.params.shopId)
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('商品不存在', '请求失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.push('/browseService/' + this.$route.params.shopId)
              }
            })
          }
          console.log(error.response.data.error)
        }
      }
    },
    async getservice () {
      try {
        const response = await modifyservice.getserviceinfo(this.$route.params.shopId, this.$route.params.serviceId, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.ruleForm.serviceName = response.data.data.service.serviceName
        this.ruleForm.serviceCalorie = response.data.data.service.serviceCalorie
        this.ruleForm.serviceCategory = response.data.data.service.serviceCategory
        this.ruleForm.serviceIntroduction = response.data.data.service.serviceIntroduction
        this.ruleForm.serviceTime = response.data.data.service.serviceTime
        this.ruleForm.imageUrl = response.data.data.service.serviceImage
        this.ruleForm.serviceLocation = response.data.data.service.serviceLocation
        console.log('成功')
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          await this.$alert('商品不存在', '请求失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.go(-1)
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('服务不存在', '请求失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
                this.$router.go(-1)
              }
            })
          }
          console.log(error.response.data.error)
        }
      }
    },
    async submitForm (formName) {
      try {
        if (this.ruleForm.serviceName === '' || this.ruleForm.serviceIntroduction === '' || this.ruleForm.serviceLocation === '' || this.ruleForm.serviceTime === '' || this.ruleForm.imageUrl === '' || this.ruleForm.serviceCategory === '') {
          await this.$alert('有必填项未填！', '申请失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
          return
        }
        this.ruleForm.disabled = true
        const response = await modifyservice.postservicechange({
          serviceName: this.ruleForm.serviceName,
          serviceCalorie: this.ruleForm.serviceCalorie,
          serviceCategory: this.ruleForm.serviceCategory,
          serviceIntroduction: this.ruleForm.serviceIntroduction,
          serviceTime: this.ruleForm.serviceTime,
          serviceLocation: this.ruleForm.serviceLocation,
          serviceImage: this.ruleForm.imageUrl
        },
        {
          headers: {'Authorization': this.$store.state.token}
        }, this.$route.params.shopId, this.$route.params.serviceId)
        if (response.data.code === 200) {
          await this.$alert('服务更改申请成功！', '申请成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/BrowseMyService/' + this.$route.params.shopId)
            }
          })
        } else {
          this.ruleForm.disabled = false
          this.error = response.data.msg
          await this.$alert(response.data.msg, '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        }
      } catch (error) {
        this.ruleForm.disabled = false
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          await this.$alert('Network Error', '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            await this.$alert('图片过大，不能超过64KB', '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        }
      }
    },
    resetForm (formName) {
      this.ruleForm.serviceCalorie = 0
      this.ruleForm.serviceTime = 0
      this.ruleForm.serviceName = ''
      this.ruleForm.serviceCategory = ''
      this.ruleForm.serviceIntroduction = ''
      this.ruleForm.serviceLocation = ''
      this.ruleForm.imageUrl = ''
      this.ruleForm.shopId = 0
    },
    handleChange (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl = event.target.result
          // console.log(this.ruleForm.imageUrl)
        }
      })
    },
    handleChange2 (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl2 = event.target.result
          // console.log(this.ruleForm.imageUrl2)
        }
      })
    },
    beforeUpload (file) {

    },
    beforeUpload2 (file) {

    },
    addrow () {
      this.ruleForm.ingredientList.push({
        ingredientName: '',
        ingredientCategory: '',
        ingredientCalorie: 0
      })
    },
    removeRow (index) {
      this.ruleForm.ingredientList.splice(index, 1)
    }
  }
}
</script>

<style scoped>
.el-header {
  background-color: #333;
}
.el-main {
  padding-top: 0;
}
.demo-ruleForm {
  max-width: 800px;
  margin: 0 auto;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 130px;
  line-height: 130px;
  text-align: center;
}

.avatar {
  width: 178px;
  height: 130px;
  display: block;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}
</style>
